; !DEBUG CONSOLE !MAKEALL !LINKALL CLEAN NOMAKEIT
;; 
; INCLUDE \masm32\include\masm32rt.inc
;; 

;
; Tests
;
.686P
.MMX
.XMM
.MODEL flat,stdcall
.STACK 4096

OPTION SCOPED
OPTION LJMP
OPTION CASEMAP:NONE

;
; inc files
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc

;
; lib files
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\masm32.lib

INCLUDE \Masm32\MACROS\macros.asm

comment * -----------------------------------------------------
        Build this template with
        "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *
Number_Of_Loop        EQU 500
Memory_Block_Size    EQU 1024*1024*6


test_thread_1 PROTO :DWORD
test_thread_2 PROTO :DWORD
test_thread_3 PROTO :DWORD
test_thread_4 PROTO :DWORD

;
; Structures
;

; Structure used to get/free the memory instance
Mem_Info STRUCT
        Instance    DWORD ?
        Init_Size    DWORD ?
        Maxi_Size    DWORD ?
        Unused_01    DWORD ?
Mem_Info ENDS

; Structure used to alloc/free memory Area
Mem_Area STRUCT
        Area_Size    DWORD ?
        Pointer_To_Free    DWORD ?
        Pointer    DWORD ?
        Unused_01    DWORD ?
Mem_Area ENDS

;
Thread_Datas STRUCT
        Arg_1    DWORD ? ; size
        Arg_2    DWORD ? ; filling value
        Arg_3    DWORD ? ; start address
        Arg_4    DWORD ? ; (ADP/Core)*2
Thread_Datas ENDS

.DATA?
thread1    DWORD ?
thread2    DWORD ?
thread3    DWORD ?
thread4    DWORD ?

.DATA
objcnt2    DWORD 0,0
objcnt4    DWORD 0,0,0,0

ALIGN 16
Mem_Instance Mem_Info <?>
Mem_Area_1 Mem_Area <?>

Thread_1_Datas Thread_Datas <?>
Thread_2_Datas Thread_Datas <?>
Thread_3_Datas Thread_Datas <?>
Thread_4_Datas Thread_Datas <?>

.CODE
ALIGN 16
;
; alloc an ALIGN 16 memory area
; note : the Mem_Info STRUCTure have to be defined previously,and must be free at the end of the program
;
; Syntax :
; mov eax,size of the memory area to alloc
; mov esi,OFFSET of a Mem_Info STRUCTure
; mov edi,OFFSET of a Mem_Area STRUCTure
; call AllocMemArea
;
; Return :
; eax = address of the aligned memory area
;
AllocMemArea PROC
        push ecx
        push edx

        mov (Mem_Area PTR [edi]).Area_Size,eax
        add eax,000000010h
        invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax
        mov (Mem_Area PTR [edi]).Pointer_To_Free,eax
        mov ecx,eax
        and ecx,00000000Fh
        jz AlreadyOk
        and eax,0FFFFFFF0h
        add eax,000000010h
AlreadyOk:
        mov (Mem_Area PTR [edi]).Pointer,eax

        pop edx
        pop ecx
    ret
AllocMemArea ENDP


ALIGN 16
;
; create a memory instance
; note : must be free at the end of the program
;
; Syntax :
; mov esi,OFFSET of a Mem_Info STRUCTure
; call CreateMemInstance
;
; Return :
; eax = the instance
;
CreateMemInstance PROC
        push ecx
        push edx

        invoke HeapCreate,HEAP_NO_SERIALIZE,(Mem_Info PTR [esi]).Init_Size,(Mem_Info PTR [esi]).Maxi_Size
        mov (Mem_Info PTR [esi]).Instance,eax

        pop edx
        pop ecx
    ret
CreateMemInstance ENDP


ALIGN 16
;
; fill a memory area with a value
;
; Syntax :
; mov eax,size
; mov edx,value
; mov edi,OFFSET memory Area start
; call Fill_Mem
;
; Return :
; nothing
;
Fill_Mem PROC
        push ecx ;; empiler ecx

; ici on traite les owords
        mov ecx,eax ;; placer la taille  copier dans ecx
        and ecx,11111111111111111111111111110000b ;; ne conserver que les bits owords en ecx
        jz Label1 ;; si ecx est gal  0,aller Label1
        add edi,ecx ;; on ajoute ecx  edi
        neg ecx ;; inverser ecx
        nop ;; ) alignement ncessaire pour un meilleur rendement
        nop ;; )
        nop ;; )
        nop ;; )
        nop ;; )
; nop ;; )
; nop ;; )
; nop ;; )
Label0: mov    DWORD PTR[edi+ecx],edx ;; placer la valeur en edi+ecx
        mov    DWORD PTR[edi+ecx+4],edx ;; placer la valeur en edi+ecx+4
        mov    DWORD PTR[edi+ecx+8],edx ;; placer la valeur en edi+ecx+8
        mov    DWORD PTR[edi+ecx+12],edx ;; placer la valeur en edi+ecx+12
        add ecx,DWORD*4 ;; on ajoute 16  ecx (notre pas de boucle)
        jnz Label0 ;; tant que ecx est diffrent de 0,aller Label0
; ici on traite les dwords
Label1: mov ecx,eax ;; placer la taille  copier dans ecx
        and ecx,00000000000000000000000000001100b ;; ne conserver que les bits dwords en ecx
        jz Label3 ;; si ecx est gal  0,aller Label3
        add edi,ecx ;; on ajoute ecx  edi
        neg ecx ;; inverser ecx
Label2: mov    DWORD PTR [edi+ecx],edx ;; placer la valeur en edi+ecx
        add ecx,DWORD ;; on ajoute 4  ecx (notre pas de boucle)
        jnz Label2 ;; tant que ecx est sign,aller Label2
; ici on traite les octets
Label3: mov ecx,eax ;; placer la taille  copier dans ecx
        and ecx,00000000000000000000000000000011b ;; ne conserver que les bits octets en ecx
        jz Label5 ;; si ecx est gal  0,aller Label5
        add edi,ecx ;; on ajoute ecx  edi
        neg ecx ;; inverser ecx
Label4: mov    BYTE PTR [edi+ecx],dl ;; placer la valeur en edi+ecx
        inc ecx ;; on ajoute 1  ecx (notre pas de boucle)
        jnz Label4 ;; tant que ecx est diffrent de 0,aller Label4
Label5: sub edi,eax ;; soustraire la taille  edi (pour retrouver l'adresse originelle)

        pop ecx ;; dsempiler ecx
    ret
Fill_Mem ENDP


ALIGN 16
;
; free a memory area
;
; Syntax :
; mov esi,OFFSET of a Mem_Info STRUCTure
; mov edi,OFFSET of a Mem_Area STRUCTure
; call FreeMemArea
;
; Return :
; nothing
;
FreeMemArea PROC
        push eax
        push ecx
        push edx

        invoke HeapFree,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE,(Mem_Area PTR [edi]).Pointer_To_Free

        pop edx
        pop ecx
        pop eax
    ret
FreeMemArea ENDP


ALIGN 16
;
; free memory instance (must be done before quit)
;
; Syntax :
; mov esi,OFFSET of a Mem_Info STRUCTure
; call FreeMemInstance
;
; Return :
; nothing
;
FreeMemInstance PROC
        push eax
        push ecx
        push edx

        invoke HeapDestroy,(Mem_Info PTR [esi]).Instance

        pop edx
        pop ecx
        pop eax
    ret
FreeMemInstance ENDP


ALIGN 16
; 
main proc

        LOCAL var :DWORD

        push esi

; --------------------
; single thread timing
; --------------------
print "===========================================",13,10
print "Run a single thread on fixed test procedure",13,10
print "===========================================",13,10

        mov eax,Mem_Area_1.Area_Size
        mov Thread_1_Datas.Arg_1,eax
        mov Thread_1_Datas.Arg_2,11111111h
        mov edx,Mem_Area_1.Pointer
        mov Thread_1_Datas.Arg_3,edx

        invoke GetTickCount
        push eax

        invoke test_thread_1,0

        invoke GetTickCount
        pop ecx
        sub eax,ecx
        print ustr$(eax)," MS Single thread timing",13,10,13,10
        invoke SleepEx,500,0
; *******************************

print "=======================================",13,10
print "Run two threads on fixed test procedure",13,10
print "=======================================",13,10

        mov eax,Mem_Area_1.Area_Size
        shr eax,1                                                     ;
        mov Thread_1_Datas.Arg_1,eax
        mov Thread_2_Datas.Arg_1,eax
        mov Thread_1_Datas.Arg_2,21212121h
        mov Thread_2_Datas.Arg_2,22222222h
        mov edx,Mem_Area_1.Pointer
        mov Thread_1_Datas.Arg_3,edx
        add edx,eax                                                   ;
        mov Thread_2_Datas.Arg_3,edx

        mov esi,OFFSET objcnt2
        invoke CreateEvent,0,FALSE,FALSE,0
        mov [esi],eax
        invoke CreateEvent,0,FALSE,FALSE,0
        mov [esi+4],eax

        invoke GetTickCount
        push eax

        invoke CreateThread,NULL,NULL,ADDR test_thread_1,[esi],NULL,NULL
        mov thread1, eax
        invoke CreateThread,NULL,NULL,ADDR test_thread_2,[esi+4],NULL,NULL
        mov thread2, eax

        invoke SetThreadPriority,thread1,THREAD_PRIORITY_HIGHEST
        invoke SetThreadPriority,thread2,THREAD_PRIORITY_HIGHEST

        ; ------------------------------
        ; synchronise thread termination
        ; ------------------------------
        invoke WaitForMultipleObjects,2,OFFSET objcnt2,TRUE,INFINITE

        invoke GetTickCount
        pop ecx
        sub eax,ecx
        print ustr$(eax)," MS Two thread timing",13,10,13,10

        invoke CloseHandle,[esi]
        invoke CloseHandle,[esi+4]

        invoke SetThreadPriority,thread1,THREAD_PRIORITY_NORMAL
        invoke SetThreadPriority,thread2,THREAD_PRIORITY_NORMAL

        invoke TerminateThread,thread1,0
        invoke TerminateThread,thread2,0

        invoke SleepEx,500,0
; *******************************

print "========================================",13,10
print "Run four threads on fixed test procedure",13,10
print "========================================",13,10

        mov eax,Mem_Area_1.Area_Size
        shr eax,2
        mov Thread_1_Datas.Arg_1,eax
        mov Thread_2_Datas.Arg_1,eax
        mov Thread_3_Datas.Arg_1,eax
        mov Thread_4_Datas.Arg_1,eax
        mov Thread_1_Datas.Arg_2,41414141h
        mov Thread_2_Datas.Arg_2,42424242h
        mov Thread_3_Datas.Arg_2,43434343h
        mov Thread_4_Datas.Arg_2,44444444h
        mov edx,Mem_Area_1.Pointer
        mov Thread_1_Datas.Arg_3,edx
        add edx,eax
        mov Thread_2_Datas.Arg_3,edx
        add edx,eax
        mov Thread_3_Datas.Arg_3,edx
        add edx,eax
        mov Thread_4_Datas.Arg_3,edx

        mov esi,OFFSET objcnt4
        invoke CreateEvent,0,FALSE,FALSE,0
        mov [esi],eax
        invoke CreateEvent,0,FALSE,FALSE,0
        mov [esi+4],eax
        invoke CreateEvent,0,FALSE,FALSE,0
        mov [esi+8],eax
        invoke CreateEvent,0,FALSE,FALSE,0
        mov [esi+12],eax

        invoke GetTickCount
        push eax

        invoke CreateThread,NULL,NULL,ADDR test_thread_1,[esi],NULL,NULL
        mov thread1, eax
        invoke CreateThread,NULL,NULL,ADDR test_thread_2,[esi+4],NULL,NULL
        mov thread2, eax
        invoke CreateThread,NULL,NULL,ADDR test_thread_3,[esi+8],NULL,NULL
        mov thread3, eax
        invoke CreateThread,NULL,NULL,ADDR test_thread_4,[esi+12],NULL,NULL
        mov thread4, eax

        invoke SetThreadPriority,thread1,THREAD_PRIORITY_HIGHEST
        invoke SetThreadPriority,thread2,THREAD_PRIORITY_HIGHEST
        invoke SetThreadPriority,thread3,THREAD_PRIORITY_HIGHEST
        invoke SetThreadPriority,thread4,THREAD_PRIORITY_HIGHEST

        ; ------------------------------
        ; synchronise thread termination
        ; ------------------------------
        invoke WaitForMultipleObjects,4,OFFSET objcnt4,TRUE,INFINITE

        invoke GetTickCount
        pop ecx
        sub eax,ecx
        print ustr$(eax)," MS Four thread timing",13,10,13,10

        invoke CloseHandle,[esi]
        invoke CloseHandle,[esi+4]
        invoke CloseHandle,[esi+8]
        invoke CloseHandle,[esi+12]

        invoke SetThreadPriority,thread1,THREAD_PRIORITY_NORMAL
        invoke SetThreadPriority,thread2,THREAD_PRIORITY_NORMAL
        invoke SetThreadPriority,thread3,THREAD_PRIORITY_NORMAL
        invoke SetThreadPriority,thread4,THREAD_PRIORITY_NORMAL
    
        invoke TerminateThread,thread1,0
        invoke TerminateThread,thread2,0
        invoke TerminateThread,thread3,0
        invoke TerminateThread,thread4,0

        invoke SleepEx,500,0
; *******************************

        pop esi

    ret

main ENDP
; 


ALIGN 16
; 
test_thread_1 PROC nThread:DWORD

        mov ecx,Number_Of_Loop
Label0:
        mov eax,Thread_1_Datas.Arg_1 ; size
        mov edx,Thread_1_Datas.Arg_2 ; fill value
        mov edi,Thread_1_Datas.Arg_3 ; area start
        call Fill_Mem

        sub ecx,1
        jnz Label0
        invoke SetEvent,nThread

    ret

test_thread_1 ENDP
; 


ALIGN 16
; 
test_thread_2 PROC nThread:DWORD

        mov ecx,Number_Of_Loop
Label0:
        mov eax,Thread_2_Datas.Arg_1 ; size
        mov edx,Thread_2_Datas.Arg_2 ; fill value
        mov edi,Thread_2_Datas.Arg_3 ; area start
        call Fill_Mem

        sub ecx,1
        jnz Label0
        invoke SetEvent,nThread

    ret

test_thread_2 ENDP
; 


ALIGN 16
; 
test_thread_3 PROC nThread:DWORD

        mov ecx,Number_Of_Loop
Label0:
        mov eax,Thread_3_Datas.Arg_1 ; size
        mov edx,Thread_3_Datas.Arg_2 ; fill value
        mov edi,Thread_3_Datas.Arg_3 ; area start
        call Fill_Mem

        sub ecx,1
        jnz Label0
        invoke SetEvent,nThread

    ret

test_thread_3 ENDP
; 


ALIGN 16
; 
test_thread_4 PROC nThread:DWORD

        mov ecx,Number_Of_Loop
Label0:
        mov eax,Thread_4_Datas.Arg_1 ; size
        mov edx,Thread_4_Datas.Arg_2 ; fill value
        mov edi,Thread_4_Datas.Arg_3 ; area start
        call Fill_Mem

        sub ecx,1
        jnz Label0
        invoke SetEvent,nThread

    ret

test_thread_4 ENDP
; 

start:
; 

        invoke GetCurrentProcess                            ;; ) fixer la priorit de notre application  haute
        invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS        ;; )
; alloc mem areas
        mov esi,OFFSET Mem_Instance
        call CreateMemInstance

        mov eax,Memory_Block_Size
        mov esi,OFFSET Mem_Instance
        mov edi,OFFSET Mem_Area_1
        call AllocMemArea

        call main

; inkey
        mov eax,input(13,10,13,10," Press ENTER to quit...")

; exit
        mov esi,OFFSET Mem_Instance
        mov edi,OFFSET Mem_Area_1
        call FreeMemArea

        mov esi,OFFSET Mem_Instance
        call FreeMemInstance

        invoke GetCurrentProcess                            ;;    ) remettre la priorit du programme  la normale
        invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS        ;;    )
        invoke ExitProcess,0

; 
end start
